#pragma once

// some defines taken from the atmel ASF
#define   GCLK_GENCTRL_ID_GCLK0_Val       0x0ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 0 */
#define   GCLK_GENCTRL_ID_GCLK1_Val       0x1ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 1 */
#define   GCLK_GENCTRL_ID_GCLK2_Val       0x2ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 2 */
#define   GCLK_GENCTRL_ID_GCLK3_Val       0x3ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 3 */
#define   GCLK_GENCTRL_ID_GCLK4_Val       0x4ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 4 */
#define   GCLK_GENCTRL_ID_GCLK5_Val       0x5ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 5 */
#define   GCLK_GENCTRL_ID_GCLK6_Val       0x6ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 6 */
#define   GCLK_GENCTRL_ID_GCLK7_Val       0x7ul  /**< \brief (GCLK_GENCTRL) Generic clock generator 7 */
#define GCLK_GENCTRL_ID_GCLK0       (GCLK_GENCTRL_ID_GCLK0_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK1       (GCLK_GENCTRL_ID_GCLK1_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK2       (GCLK_GENCTRL_ID_GCLK2_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK3       (GCLK_GENCTRL_ID_GCLK3_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK4       (GCLK_GENCTRL_ID_GCLK4_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK5       (GCLK_GENCTRL_ID_GCLK5_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK6       (GCLK_GENCTRL_ID_GCLK6_Val     << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID_GCLK7       (GCLK_GENCTRL_ID_GCLK7_Val     << GCLK_GENCTRL_ID_Pos)

#define SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_XOSC32K 0
#define SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_XOSC 1
#define SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_GCLK 2

#include "samd10.h"
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <string.h>
